"{ Package: 'stx:libcomp' }"

ParseNodeVisitor subclass:#ParseNodeValidator
	instanceVariableNames:'nodeStack'
	classVariableNames:''
	poolDictionaries:''
	category:'System-Compiler-Support'
!

!ParseNodeValidator class methodsFor:'documentation'!

documentation
"
    A helper class used to validate parse tree, i.e. parent instvar,
    startPosition/endPositions. Useful only for Parser debugging/hacking.

    [author:]
        Jan Vrany <jan.vrany@fit.cvut.cz>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!ParseNodeValidator class methodsFor:'validation'!

validate: aParseNode

    ^self basicNew validate: aParseNode

    "Created: / 20-07-2011 / 20:31:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

validateImage

    self validateImage: false.

    "Created: / 20-07-2011 / 20:41:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

validateImage: stopOnError

    Smalltalk allClassesDo:[:cls|
        cls isLoaded ifTrue:[
            Transcript nextPut:$..
            cls methodsDo:[:mth|
                [ 
                    self validate: (Parser parseMethod: mth source) tree 
                ] on: Error do:[:ex|
                    Transcript 
                        cr;
                        show: mth printString;
                        show: '...FAILED!!';
                        cr.                        
                    stopOnError ifTrue:[
                        ex pass
                    ].
                ]                
            ].
        ].
    ].

    "Created: / 20-07-2011 / 20:42:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ParseNodeValidator methodsFor:'validation'!

validate: tree

    tree isNil ifTrue:[^self].

    nodeStack := Stack with: nil.

    ^self visit: tree

    "Created: / 20-07-2011 / 20:31:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ParseNodeValidator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libcomp/ParseNodeValidator.st,v 1.2 2011-07-25 21:51:46 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libcomp/ParseNodeValidator.st,v 1.2 2011-07-25 21:51:46 vrany Exp $'
! !
